
 package tjp;

import java.util.*;

import org.aspectj.asm.IRelationship;
import org.aspectj.org.eclipse.jdt.core.IJavaElement;
import org.eclipse.ajdt.core.AspectJPlugin;
import org.eclipse.ajdt.core.builder.AJBuilder;
import org.eclipse.ajdt.core.lazystart.IAdviceChangedListener;
import org.eclipse.ajdt.core.model.AJModel;
import org.eclipse.ajdt.core.model.AJProjectModelFacade;
import org.eclipse.ajdt.core.model.AJProjectModelFactory;
import org.eclipse.ajdt.core.model.AJRelationship;
import org.eclipse.ajdt.core.model.AJRelationshipManager;
import org.eclipse.ajdt.core.model.AJRelationshipType;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.jdt.internal.compiler.ast.ThisReference;
import com.sun.xml.internal.bind.v2.schemagen.xmlschema.List;


public class MyAdviceListener implements IAdviceChangedListener { 
	   // get the project
	   IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject("C:\\Documents and Settings\\Shashank\\workspaceDev\\TJP Example");
	 
	   public void adviceChanged() {
	 
	     // the AJProjectModelFacade is a facade into the AspectJ's model.  Provides functionality
	     // to query the AspectJ cross cutting model as well as to translate back and forth between
	     // JDT elements and AspectJ elements
	     AJProjectModelFacade model = AJProjectModelFactory.getInstance().getModelForProject(project);
	 
	     // You can narrow this to include on certain kinds of relationships
	     AJRelationshipType[] relsTypes = AJRelationshipManager.getAllRelationshipTypes();
	 
	     // check first to see if there is a model
	     // will return false if there has not yet beena successful build of this project
	     if (model.hasModel()) {
	 
	       // all relationships for project
	       // can also query for relationships on individual elements or compilation units
	       java.util.List<IRelationship> rels = model.getRelationshipsForProject(relsTypes);
	       for (IRelationship rel : rels) {
	         // Source is an IProgramElement handle, which refers to a piece of the program in AspectJ's World
	         org.eclipse.jdt.core.IJavaElement source = model.programElementToJavaElement(rel.getSourceHandle());
	         // do something with the source...
	         System.out.println(source.getElementName());
	 
	         for (String targetHandle : rel.getTargets()) {
	           // Can have multiple targets
	           org.eclipse.jdt.core.IJavaElement target = model.programElementToJavaElement(targetHandle);
	           // do something with the target...
	           System.out.println(target.getElementName());
	         }
	       }
	     }
	   }
	 }